package com.fs.app.controller;


import com.fs.app.annotation.Login;
import com.fs.app.utils.JwtUtils;
import com.fs.common.config.FSConfig;
import com.fs.common.core.domain.AjaxResult;
import com.fs.common.core.domain.R;
import com.fs.common.core.domain.entity.SysUser;
import com.fs.common.core.redis.RedisCache;
import com.fs.common.utils.ServletUtils;
import com.fs.common.utils.StringUtils;
import com.fs.common.utils.file.FileUploadUtils;
import com.fs.core.config.ServerConfig;
import com.fs.crm.domain.CrmEvent;
import com.fs.crm.service.ICrmCustomerService;
import com.fs.crm.service.ICrmCustomerUserService;
import com.fs.crm.service.ICrmEventService;
import com.fs.crm.service.ICrmMsgService;
import com.fs.system.service.ISysConfigService;
import com.fs.system.service.ISysDictDataService;
import com.fs.system.service.ISysUserService;
import com.fs.system.vo.DictVO;
import com.fs.voice.service.IVoiceService;
import com.github.xiaoymin.swaggerbootstrapui.util.CommonUtils;
import io.jsonwebtoken.Claims;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletRequest;
import java.util.List;
import java.util.concurrent.TimeUnit;


public class AppBaseController {
	@Autowired
	JwtUtils jwtUtils;
	@Autowired
	RedisCache redisCache;

//	public String getUserId()
//	{
//		String headValue =  ServletUtils.getRequest().getHeader("APPToken");
//		if(StringUtils.isNotEmpty(headValue)){
//			Claims claims=jwtUtils.getClaimByToken(headValue);
//			if(StringUtils.isNotEmpty(claims)){
//				String userId = claims.getSubject().toString();
//				return userId;
//			}
//			else{
//				return null;
//			}
//
//		}
//		else{
//			return null;
//		}
//
//	}

	public enum TokenStrategy {
		DEFAULT,            // 默认策略：优先 APPToken，回退 UserToken
		USER_TOKEN_ONLY,    // 仅使用 UserToken
		// 未来可扩展其他策略，如 BACKUP_TOKEN_ONLY
	}

	/**
	 * 获取用户ID（默认优先 APPToken，传参可覆盖策略）
	 * @param strategy 可选策略，默认 DEFAULT（APPToken优先）
	 */
	public String getUserId(TokenStrategy strategy) {
		if (strategy == TokenStrategy.USER_TOKEN_ONLY) {
			return parseToken("UserToken"); // 仅 UserToken
		} else {
			// 默认策略：优先 APPToken
			return parseToken("APPToken");
		}
	}

	// 不传参数时，默认走 DEFAULT 策略
	public String getUserId() {
		return getUserId(TokenStrategy.DEFAULT);
	}


	/**
	 * 通用方法：从指定 Token 获取 userId（私有方法，复用逻辑）
	 */
	private String parseToken(String tokenHeaderName) {
		String token = ServletUtils.getRequest().getHeader(tokenHeaderName);
		if (StringUtils.isNotEmpty(token)) {
			Claims claims = jwtUtils.getClaimByToken(token);
			if (claims != null && StringUtils.isNotEmpty(claims.getSubject())) {
				return claims.getSubject();
			}
		}
		return null;
	}


}
